-- set some global properties on the jit.gl.lua object
this.autowatch = 1

-- load in the OpenGL module
local gl = require("opengl")
local GL = gl

gshape = jit.new("jit.gl.gridshape", this.drawto)
gshape.automatic = 0
gshape.shape="plane"
gshape.dim={1,1}
gshape.lighting_enable = 1
gshape.depth_enable = 0
gshape.smooth_shading = 1
gshape.displaylist=1
gshape.blend_enable = 1
gshape.blend = "alphablend"


charTexture = jit.new("jit.gl.texture", this.drawto)
charTexture.file="king-big.png"
charTexture.name = "glyphtexture"
charTexture.adapt = 1
charTexture.rectangle = 0


charShader = jit.new("jit.gl.shader", this.drawto)
charShader.file="texture_atlas.jxs"
charShader.name = "glyphshader"


function draw()
	local charcounter=0
   	jit.gl.draw_begin(gshape)
	charTexture:bind()
	for y=0, 4, 1 do
		for x=0, 99, 1 do
			charcounter=charcounter+1
			
			gl.PushMatrix()

			gl.Translate(x*1.1, y*2.1,0)
			gl.Scale(.5,1.,1.)

			charShader:param("glyph", charcounter)
			charShader:param("bgcolor",math.random(),math.random(),math.random(),.5)
			charShader:param("glitchamount",math.random())

			charShader:bind()
   			gshape:drawraw()
			charShader:unbind()
		
			gl.PopMatrix()
			
		end
	end
	charTexture:unbind()

   	jit.gl.draw_end(gshape)

end