uniform sampler2D tex0; // assumed character map texture is square.

uniform vec2 dimensions; // how many letters per row

// define our varying texture coordinates 
varying vec2 texcoord0;

uniform float glyph; // selected index for our glyph

uniform float glitchamount;

uniform vec4 bgcolor;

void main (void) 
{
	
	float glyphMix = fract(glyph);
	float glyphIndex = floor(glyph);
			
	// find our row and column from our index
	float row1 = mod(float(int(glyphIndex) / int(dimensions.x)), dimensions.x);
	float col1 = mod(glyphIndex, dimensions.y);

	vec2 glyphTextureCoord1 = vec2(
	    (col1 + texcoord0.x) / dimensions.x,
	    (row1 + texcoord0.y) / dimensions.y);

	vec4 color = vec4(1.,1.,0.,0.);
	//color.a = texture2D(tex0, glyphTextureCoord1).a;

	vec2 texCoordR = glyphTextureCoord1+vec2(0.015,0.01)*glitchamount*0.17;
	vec2 texCoordG = glyphTextureCoord1+vec2(0.02,0.)*glitchamount*0.09;
	vec2 texCoordB = glyphTextureCoord1+vec2(0.,-0.015)*glitchamount*0.1;

	
	
	
	texCoordR.y+=sin(texcoord0.y*20)*.01*glitchamount;
	color.r = texture2D(tex0,texCoordR).a;
	color.g = texture2D(tex0,texCoordG).a;
	color.b = texture2D(tex0,texCoordB).a;
	color.a = color.a+color.r;//*0.33;
	color.a = color.a+color.g;//*0.33;
	color.a = color.a+color.b;//*0.33;
	
	//float a = texture2D(tex0, glyphTextureCoord1).a;
	//vec4 modcolor=color*a+bgcolor*(1-a);
	
	
	vec4 modcolor=color+bgcolor;
	gl_FragColor = modcolor;
	//gl_FragColor = color;

	//gl_FragColor = texture2D(tex0, glyphTextureCoord1);
}